#ifndef _CONFIG_H
#define _CONFIG_H

struct User;
struct Banned;

class Config {

public:

	Config();
	~Config();

	void loadConfig();

	int getPlayerMax();
	int getBackupInterval();
	char *getName();
	char *getMotd();
	char *getPort();
	bool getPublic();
	bool getVerify();

	std::vector<User> getUserList();
	std::vector<Banned> getBannedList();

private:

	void writeConfig();

	int parseConfig();
	void parseUserList();
	void parseBannedList();

	int playerMax;
	int backupInterval;
	
	char cfgName[64];
	char cfgMotd[64];
	char cfgPort[6];
	
	bool cfgPublic;
	bool cfgVerify;
	bool cfgPhysWater;
	bool cfgPhysLava;
	bool cfgPhysSand;

	std::vector<User> userList;
	std::vector<Banned> bannedList;

};

#endif
