#include <cstdio>
#include <cstring>
#include <cstdarg>
#include <ctime>
#include "defines.h"
#include "Logger.h"

void Logger::start() {
	FILE *logFile;
	newmutex(mutexLog);
	logFile = fopen("server.log", "a");
	fputs("-------------------NEW LOGGING SESSION-------------------\n", logFile);
	fclose(logFile);
}

void Logger::add(const char *format, ...) {
	FILE *logFile;
	char logEntry[256], formatStr[32], vstr[256];
	struct tm *ts;
	time_t utime;
	va_list args;

	time(&utime);
	ts = localtime(&utime);

	formatStr[0] = 0;

	if(ts->tm_hour < 10)
		strcat(formatStr, "0");
	strcat(formatStr, "%d:");

	if(ts->tm_min < 10)
		strcat(formatStr, "0");
	strcat(formatStr, "%d:");

	if(ts->tm_sec < 10)
		strcat(formatStr, "0");
	strcat(formatStr, "%d\t%s");

    va_start(args, format);
    vsprintf(vstr, format, args);
	va_end(args);

	sprintf(logEntry, formatStr, ts->tm_hour, ts->tm_min, ts->tm_sec, vstr);

	printf("%s", logEntry);

	lock(mutexLog);
	logFile = fopen("server.log", "a");
	fputs(logEntry, logFile);
	fclose(logFile);
	unlock(mutexLog);
}
